# eztdvd [AU] video scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  vw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    vw.setRegion("Region 4")
    vw.setLanguage("English")
    vw.setCurrencySymbol("$")


    # Find Title
    title = searchForPlus(source, "id=\"productpage\"")
    title = searchForPlus(title, "<h1>")
    i = string.find(title, "<")
    title = stripText(title[0:i])

    i = string.find(title, "(")

    if i != -1:
        title = stripText(title[0:i])

    vw.setTitle(title)


    # Find Price
    i = string.find(source, "class=\"price\"")

    if (i != -1):
        value = searchFor(source, "class=\"price\"")
        value = searchFor(value, "$")
        i = string.find(value, "<")
        value = stripText(value[0:i])
        vw.setItemValue(value)

        vw.setPurchasePrice(vw.getItemValue())
        vw.setPurchaseDate(Date())
        vw.setPurchasePlace(vw.getSource())


    # Find Image
    i = string.find(source, "class=\"productpack_fl_left\"")

    if i != -1:
        image = searchForPlus(source, "class=\"productpack_fl_left\"")
        image = searchForPlus(image, " src=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        i = string.find(image, "dvd-no-image.gif")

        if i == -1:
            vw.setImage1(image)


    # Find Released date
    i = string.find(source, ">First Released<")

    if i != -1:
        date = searchForPlus(source, ">First Released<")
        date = searchForPlus(date, "<dd>")
        i = string.find(date, "<")
        date = stripText(date[0:i])
        vw.setReleaseDate(date)


    # Find categories
    i = string.find(source, ">Genres<")

    if i != -1:
        cats = searchForPlus(source, ">Genres<")
        cats = searchForPlus(cats, "<dd>")
        i = string.find(cats, "</dd>")
        cats = stripText(cats[0:i])
        vw.setCategory1(cats)

        i = string.find(cats, ",")

        if i != -1:
            vw.setCategory1(stripText(cats[0:i]))
            cats = stripText(cats[i+1:])
            vw.setCategory2(cats)

            i = string.find(cats, ",")

            if i != -1:
                vw.setCategory2(stripText(cats[0:i]))
                cats = stripText(cats[i+1:])
                vw.setCategory3(cats)

                i = string.find(cats, ",")

                if i != -1:
                    vw.setCategory3(stripText(cats[0:i]))


    # Find Region
    i = string.find(source, ">DVD<")

    if i != -1:
        region = searchForPlus(source, ">DVD<")
        region = searchForPlus(region, "<dd>")
        i = string.find(region, "<")
        region = stripText(region[0:i])

        i = string.find(region, "(")

        if i != -1:
            region = stripText(region[0:i])

        vw.setRegion(date)
        

    # Find Comments
    i = string.find(source, "class=\"desc\"")

    if (i != -1):
        comments = searchForPlus(source, "class=\"desc\"")
        comments = searchForPlus(comments, ">")
        i = string.find(comments, "</div>")
        comments = comments[0:i]
        vw.setProductInfo(comments)


    # Find Actors
    i = string.find(source, "<dt>Actors</dt>")

    if i != -1:
        actors = searchForPlus(source, "<dt>Actors</dt>")
        actors = searchForPlus(actors, "<dd")
        i = string.find(actors, "</dd>")
        actors = stripText(actors[0:i])

        while (searchFor(actors, "\">") != None):
            actors = searchForPlus(actors, "\">")
            i = string.find(actors, "<")
            actor = stripText(actors[0:i])
            vw.setActor(actor)


    # Find Director
    i = string.find(source, "<dt>Director</dt>")

    if i != -1:
        director = searchForPlus(source, "<dt>Director</dt>")
        director = searchForPlus(director, "<dd")
        director = searchForPlus(director, "\">")
        i = string.find(director, "<")
        director = stripText(director[0:i])
        vw.setDirector(director)


    # Find Studio
    i = string.find(source, ">Distributor<")

    if i != -1:
        studio = searchForPlus(source, ">Distributor<")
        studio = searchForPlus(studio, "<dd")
        studio = searchForPlus(studio, ">")
        i = string.find(studio, "<")
        studio = stripText(studio[0:i])
        vw.setStudio(studio)


    # Find Rating
    i = string.find(source, ">Rating<")

    if i != -1:
        cert = searchForPlus(source, ">Rating<")
        cert = searchForPlus(cert, "<dd")
        cert = searchForPlus(cert, ">")
        i = string.find(cert, "<")
        cert = stripText(cert[0:i])
        vw.setCertification(cert)


    # Find Copyright date
    i = string.find(source, ">Year of Production<")

    if i != -1:
        date = searchForPlus(source, ">Year of Production<")
        date = searchForPlus(date, "<dd")
        date = searchForPlus(date, ">")
        i = string.find(date, "<")
        date = stripText(date[0:i])
        vw.setCopyrightDate(date)


    # Find running time
    i = string.find(source, ">Run Time")

    if i != -1:
        runtime = searchForPlus(source, ">Run Time")
        runtime = searchForPlus(runtime, "<dd")
        runtime = searchForPlus(runtime, ">")
        i = string.find(runtime, "<")
        runtime = stripText(runtime[0:i])
        vw.setRunningTime(runtime)


    # Find Language
    i = string.find(source, ">Language<")

    if i != -1:
        language = searchForPlus(source, ">Language<")
        language = searchForPlus(language, "<dd")
        language = searchForPlus(language, "<li>")
        i = string.find(language, "<")
        language = stripText(language[0:i])
        vw.setLanguage(language)


    # Find Sound
    i = string.find(source, ">Audio Format<")

    if i != -1:
        sound = searchForPlus(source, ">Audio Format<")
        sound = searchForPlus(sound, "<dd")
        sound = searchForPlus(sound, "<li>")
        i = string.find(sound, "<")
        sound = stripText(sound[0:i])
        vw.setSound(sound)


    # Find Aspect Ratio
    i = string.find(source, ">Aspect Ratio<")

    if i != -1:
        aspect = searchForPlus(source, ">Aspect Ratio<")
        aspect = searchForPlus(aspect, "<dd")
        aspect = searchForPlus(aspect, "<li>")
        i = string.find(aspect, "<")
        aspect = stripText(aspect[0:i])
        vw.setAspectRatio(aspect)


    # Find Aspect Ratio
    i = string.find(source, ">Transfer Aspect Ratio<")

    if i != -1:
        aspect = searchForPlus(source, ">Transfer Aspect Ratio<")
        aspect = searchForPlus(aspect, "<dd")
        aspect = searchForPlus(aspect, "<li>")
        i = string.find(aspect, "<")
        aspect = stripText(aspect[0:i])
        vw.setAspectRatio(aspect)





try:
    vw.setVideoObject(Video)
    extract(source)
finally:
    if os.path.exists(vw.getDocsDir() + "vwuserexit.py"):
        execfile(vw.getDocsDir() + "vwuserexit.py") in globals()
