# amazon.fr scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    rw.setCurrencySymbol("")
    rw.setPublicationPlace("Italy")
    rw.setLanguage("Italiano")


    i = string.find(source, "id=\"result_0\"")

    if i != -1:
        source = searchForPlus(source, "id=\"result_0\"")
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        url = stripText(source[0:i])
        http = HTTPConnection()
        
        # This triggers different page format, see if we really need it.
        #try:
        #    http.setGenericUserAgent()
        #except:
        #    print "Unable to set UA"

        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(rw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()


    # Find Image
    image = ""
    i = string.find(source, "registerImage(\"original_image\"")

    if i != -1:
        images = searchForPlus(source, "registerImage(\"original_image\"")
        images = searchForPlus(images, "\"")
        i = string.find(images, "\"")
        image = stripText(images[0:i])

        i = string.find(image, "no-image")

        if i == -1:
            i = string.find(image, ",")

            if i != -1:
                j = string.rfind(image[i:], ",")
                image = stripText(image[0:i] + image[i+j+1:])

            i = string.find(image, "_AA")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                rw.setLargeImage1(large)
                image = stripText(image[0:i] + "_SL280" + image[j:])
                rw.setImage1(image)
            else:
                rw.setImage1(image)


    # Find Image
    tag = "id='imageBlock'"
    i = string.find(source, tag)

    if i == -1:
        tag = "id=\"imageBlock\""
        i = string.find(source, tag)

    if i != -1:
        images = searchForPlus(source, tag)
        images = searchForPlus(images, "src=\"")
        i = string.find(images, "\"")
        image = stripText(images[0:i])

        i = string.find(image, "data:")

        if i != -1:
            image = ""

        i = string.find(image, "no-img")

        if i == -1:
            i = string.find(image, "/loadIndicators/")

        if i == -1:
            i = string.find(image, ",")

            if i != -1:
                j = string.rfind(image[i:], ",")
                k = string.find(image[i+j:], "_")

                if k != -1:
                    j = j + (k - 1)

                imagex = stripText(image[0:i] + image[i+j+1:])

                if string.find(imagex, "_SY") == -1 & string.find(imagex, "_AA") == -1:
                    imagex = stripText(image[0:i] + "_SY300" + image[i+j+1:])

                image = imagex
                

            i = string.find(image, "_AA")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                rw.setLargeImage1(large)
                image = stripText(image[0:i] + "_SL280" + image[j:])
                rw.setImage1(image)

            tag = "_SY300_"
            i = string.find(image, tag)

            if i == -1:
                tag = "_SX225_"
                i = string.find(image, tag)

            if i != -1:
                large = string.replace(image, tag, "_SY500_")
                rw.setLargeImage1(large)
                rw.setImage1(image)
            else:
                rw.setImage1(image)

    if rw.getLargeImage1() == None:
        i = string.find(source, "class=\"quorus-product-photo\"")

        if i != -1:
            images = stripText(source[i-200:])
            images = searchForPlus(images, "src=\"")
            i = string.find(images, "\"")
            image = stripText(images[0:i])

            i = string.find(image, "_SL")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                rw.setLargeImage1(large)

    if rw.getLargeImage1() == None:
        i = string.find(source, "'imageGalleryData'")

        if i != -1:
            images = searchForPlus(source, "'imageGalleryData'")
            i = string.find(images, "mainUrl\":\"")

            if i != -1:
                images = searchForPlus(images, "mainUrl\":\"")
                i = string.find(images, "\"")
                image = stripText(images[0:i])
                rw.setLargeImage1(image)

    if rw.getImage1() == None:
        tag = "'imageGalleryData'"
        i = string.find(source, tag)

        if i != -1:
            images = searchForPlus(source, tag)
            i = string.find(source, "mainUrl\":\"")

            if i != -1:
                images = searchForPlus(images, "mainUrl\":\"")
                i = string.find(images, "\"")
                image = stripText(images[0:i])
                rw.setImage1(image)
                rw.setLargeImage1(image)

                tag = "id=\"miniATF_imageColumn\""
                i = string.find(source, tag)

                if i != -1:
                    images = searchForPlus(images, tag)
                    images = searchForPlus(images, "src=\"")
                    i = string.find(images, "\"")
                    image = stripText(images[0:i])
                    rw.setImage1(image)

    if rw.getImage1() == None:
        tag = "id=\"mainImageContainer\""
        i = string.find(source, tag)

        if i != -1:
            images = searchForPlus(source, tag)
            images = searchForPlus(images, "src=\"")
            i = string.find(images, "\"")
            image = stripText(images[0:i])
            rw.setImage1(image)

            i = string.find(images, "id=\"mainImage\"")

            if i != -1:
                images = searchForPlus(images, "id=\"mainImage\"")
                images = searchForPlus(images, "&quot;")
                i = string.find(images, "&quot;")
                image = stripText(images[0:i])
                rw.setLargeImage1(image)


    # Find new price/count
    i = string.find(source, "dp_olp_new")

    if i != -1:
        new = searchForPlus(source, "dp_olp_new")
        new = searchForPlus(new, "&condition=new")
        new = searchForPlus(new, ">")
        new = searchForPlus(new, " ")
        new = stripText(new)
        i = string.find(new, "<")
        rw.setNewCount(new[0:i])

        if rw.getNewCount() != "0":
            new = searchForPlus(new, "EUR")
            i = string.find(new, "<")
            rw.setNewPrice(new[0:i])


    # Find used price/count
    i = string.find(source, "ref=dp_olp_used")

    if i != -1:
        used = searchForPlus(source, "ref=dp_olp_used")
        used = searchForPlus(used, "&condition=used")
        used = searchForPlus(used, ">")
        used = searchForPlus(used, " ")
        used = stripText(used)
        i = string.find(used, "<")
        rw.setUsedCount(used[0:i])

        if rw.getUsedCount() != "0":
            used = searchForPlus(used, "EUR")
            i = string.find(used, "<")
            rw.setUsedPrice(used[0:i])


    # Find collectible price/count
    i = string.find(source, "olp-collectible olp-link")

    if i != -1:
        col = searchForPlus(source, "olp-collectible olp-link")
        col = searchForPlus(col, "&amp;condition=collectible")
        col = searchForPlus(col, ">")
        col = stripText(col)
        i = string.find(col, "&nbsp;")
        rw.setCollectibleCount(col[0:i])

        if rw.getCollectibleCount() != "0":
            col = searchForPlus(col, "EUR")
            i = string.find(col, "<")
            rw.setCollectiblePrice(col[0:i])


    # Find Title
    tag = "id='title'"

    if string.find(source, tag) == -1:
        tag = "<h1 id=\"title\""

    title = searchForPlus(source, tag)
    title = searchForPlus(title, "roductTitle\"")
    title = searchForPlus(title, ">")
    title = stripText(title)

    if title.startswith("<span") == 1:
        title = searchForPlus(title, ">")

    i = string.find(title, "<")
    title = stripText(title[0:i])

    i = string.find(title, "(")

    if i != -1:
        title = stripText(title[0:i])

    rw.setTitle(title)


    # Find Author
    authorList = []
    authors = searchForPlus(source, tag)
    tag = "field-author="

    i = string.find(authors, tag)
    print "I=",i

    if i != -1 and i <= 5000:
        authors = searchFor(authors, tag)

        i = string.find(authors, "</div>")
        authors = stripText(authors[0:i])
        authorList = []

        while (searchFor(authors, tag) != None):
            authors = searchForPlus(authors, tag)
            authors = searchForPlus(authors, "\">")
            i = string.find(authors, "<")
            author = stripText(authors[0:i])
            i = string.find(authors, "class=\"contribution\"")

            if i != -1:
                authors = searchForPlus(authors, "class=\"contribution\"")
                authors = searchForPlus(authors, "class=\"a-color-secondary\">")
                authors = stripText(authors)

                if authors.startswith("(") == 1:
                    i = string.find(authors, ")")
                    role = stripText(authors[0:i+1])

                    if role == "(Illustrator)":
                        rw.setIllustrator(author)
                        author = ""
                    elif role == "(Traduttore)":
                        rw.setTranslator(author)
                        author = ""
                    elif role == "(Editor)":
                        rw.setEditor(author)
                        author = ""
                
            if author != "":
                authorList.append(author)

        rw.setAuthors(authorList)


    # Find List price
    i = string.find(source, ">Prezzo consigliato:")

    if i != -1:
        listprice = searchForPlus(source,  ">Prezzo consigliato:")
        listprice = searchForPlus(listprice,  "EUR ")
        i = string.find(listprice, "<")
        listprice = stripText(listprice[0:i])
        rw.setListPrice(listprice)


    # Find value
    i = string.find(source, "a-color-price offer-price")

    if i != -1:
        value = searchForPlus(source,  "a-color-price offer-price")
        value = searchForPlus(value,  "EUR ")
        i = string.find(value, "<")
        value = stripText(value[0:i])
        rw.setItemValue(value)
    else:
        rw.setItemValue(rw.getListPrice())

    rw.setPurchasePrice(rw.getItemValue())
    rw.setPurchaseDate(Date())
    rw.setPurchasePlace(rw.getSource())


    # Find Comments
    tag = "id=\"bookDesc_override_CSS\""
    i = string.find(source, tag)

    if i != -1:
        comments = searchForPlus(source, tag)
        comments = searchForPlus(comments, "<noscript>")
        i = string.find(comments, "</noscript>")
        comments = stripText(comments[0:i])

        i = string.find(comments, "<div class=\"seeAll\">")

        if i != -1:
            comments = comments[0:i]

        i = string.find(comments, "</form>")

        if i != -1:
            comments = comments[0:i]

        i = string.find(comments, "<hr noshade")

        if i != -1:
            comments = comments[0:i]

        # Fixed in 3.16
        comments =  string.replace(comments, "&#xC8;", "")
        comments =  string.replace(comments, "&#xF9;", "")
        rw.setProductInfo(comments)


    i = searchForPlus(source, "<a name=\"productDetails\"")

    if i != -1:
        attributes = searchForPlus(source, "<a name=\"productDetails\"")
        i = string.find(attributes, "</ul>")
        attributes = attributes[0:i]

        # Find Format
        format = searchForPlus(attributes, "<b>")

        if format.startswith("Formato:") == 1:
            format = searchForPlus(format, ">")

        i = string.find(format, "<")
        format = stripText(format[0:i])
        i = string.find(format, ":")

        if i != -1:
            format = stripText(format[0:i])

        rw.setFormat(format)
    
        # Find Pages
        attributes = searchForPlus(attributes, "</b>")
        i = string.find(attributes, "pagine")

        if i != -1:
            pages = stripText(attributes[0:i-1])
            rw.setPages(pages)

        # Find Publisher
        attributes = searchForPlus(attributes,"<b>Editor")
        attributes = searchForPlus(attributes, ">")
        i = string.find(attributes, "<")
        publisher = stripText(attributes[0:i])

        i = string.find(publisher, "\n")

        if i != -1:
            pub1 = stripText(publisher[0:i])
            pub2 = stripText(publisher[i+1:])
            publisher = pub1 + " " + pub2

        i = string.find(publisher, "\n")

        if i != -1:
            publisher = stripText(publisher[0:i])

        i = string.find(publisher, "(")

        if i != -1:
            date = stripText(publisher[i+1:])
            publisher = stripText(publisher[0:i])
            i = string.find(date, ")")
            date = stripText(date[0:i])
            rw.setReleaseDate(date)

        i = string.find(publisher, ";")

        if i != -1:
            publisher = stripText(publisher[0:i])

        i = string.find(publisher, "&nbsp")

        if (i != -1):
            publisher = stripText(publisher[0:i])
                
        rw.setPublisher(publisher)


    # Find language if any
    i = string.find(attributes, ">Lingua:")

    if i != -1:
        attributes = searchForPlus(attributes, ">Lingua:")
        attributes = searchForPlus(attributes, ">")
        i = string.find(attributes, "<")
        language = stripText(attributes[0:i])
        rw.setLanguage(language)

    
    # Find ISBN
    i = string.find(attributes, "ISBN-13:")

    if i != -1:
        attributes = searchForPlus(attributes, "ISBN-13:")
        attributes = searchForPlus(attributes, ">")
        i = string.find(attributes, "<")
        isbn = stripText(attributes[0:i])
        rw.setISBN(isbn)

    # Find Dimensions
    i = string.find(source, "Dimensions (en&nbsp;cm)&nbsp;:")

    if i != -1:
       source = searchForPlus(source, "Dimensions (en&nbsp;cm)&nbsp;:")
       source = searchForPlus(source, ">")
       i = string.find(source, "<")
       # sometimes this is left blank. Only include for non-null
       if i>1:
           dimensions = stripText(source[0:i]) + " cm"

       rw.setDimensions(dimensions)


    # Find category
    i = string.find(source, ">Ricerca articoli simili per categoria<")

    if (i != -1):
        cats = searchForPlus(source, ">Ricerca articoli simili per categoria<")
        cats = searchForPlus(cats, "\">")
        i = string.find(cats, "</ul>")
        cats = stripText(cats[0:i])

        ccount = 1

        while (searchFor(cats, "href=\"") != None):
            cats = searchForPlus(cats, "href=\"")
            cats = searchForPlus(cats, "\">")
            i = string.find(cats, "<")
            cat = stripText(cats[0:i])

            if cat == "Libri":
                continue

            if cat == "Ofertas":
                continue

            if cat == "Kindle eBooks":
                continue

            if ccount == 1:
                rw.setCategory1(cat)
            elif ccount == 2:
                rw.setCategory2(cat)
            else:
                rw.setCategory3(cat)
                break

            ccount = ccount + 1


try:
    rw.setBookObject(Book)
    extract(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
